diff -ruN ../nakedmudv2.1.1/src/Makefile src/Makefile
--- ../nakedmudv2.1.1/src/Makefile	Sun May  8 15:04:45 2005
+++ src/Makefile	Thu May 12 17:19:36 2005
@@ -35,10 +35,10 @@
 	   \
 	   races.c \
 	   \
-	   log.c auxiliary.c login.c \
+	   log.c auxiliary.c account_handler.c char_gen.c \
 	   \
 	   world.c character.c room.c exit.c extra_descs.c object.c body.c \
-	   zone.c dialog.c room_reset.c \
+	   zone.c dialog.c room_reset.c account.c \
 	   \
 	   list.c property_table.c hashtable.c map.c storage.c set.c \
 	   buffer.c bitvector.c
@@ -70,10 +70,8 @@
 # clear all of the .o files and all of the save files that emacs makes
 clean:
 	rm -f NakedMud
-	rm -f *.o
-	rm -f */*.o
-	rm -f *~
-	rm -f */*~
+	rm -f *.o $(patsubst %,%/*.o, $(MODULES))
+	rm -f *~ $(patsubst %,%/*~, $(MODULES))
 
 # include all of our dependencies
 include $(patsubst %.c,%.d, $(SRC))
diff -ruN ../nakedmudv2.1.1/src/account.c src/account.c
--- ../nakedmudv2.1.1/src/account.c	Wed Dec 31 17:00:00 1969
+++ src/account.c	Thu May 12 17:08:52 2005
@@ -0,0 +1,144 @@
+//*****************************************************************************
+//
+// account.c
+//
+// Players first create an account, and then they can begin creating players.
+// The main purpose of an account is to hold all of the information relevant to
+// one player, which might extend all of that player's game characters. If you 
+// plan on adding any other information to accounts, it is strongly suggested 
+// you do so through auxiliary data (see auxiliary.h).
+//
+// For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO ACCOUNTS, IT
+// IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
+//
+//*****************************************************************************
+
+#include "mud.h"
+#include "auxiliary.h"
+#include "storage.h"
+#include "account.h"
+
+
+
+//*****************************************************************************
+// local datastructures, variables, defines, and functions
+//*****************************************************************************
+struct account_data {
+  char          *name; // the name of our account
+  char      *password; // our password to log on
+  LIST    *characters; // our list of character names
+  HASHTABLE      *aux; // auxiliary data we have installed
+};
+
+
+//
+// returns a storage set with a "name" key in it, corresponding to the argument
+// passed in.
+STORAGE_SET *accountStoreChar(const char *name) {
+  STORAGE_SET *set = new_storage_set();
+  store_string(set, "name", name);
+  return set;
+}
+
+
+//
+// parses out a character name from a storage set holding an account character
+// entry.
+char *accountReadChar(STORAGE_SET *set) {
+  return strdup(read_string(set, "name"));
+}
+
+
+
+//*****************************************************************************
+// implementation of account.h
+//*****************************************************************************
+ACCOUNT_DATA *newAccount(void) {
+  ACCOUNT_DATA *account = malloc(sizeof(ACCOUNT_DATA));
+  account->name         = strdup("");
+  account->password     = strdup("");
+  account->aux          = newAuxiliaryData(AUXILIARY_TYPE_ACCOUNT);
+  account->characters   = newList();
+  return account;
+}
+
+void deleteAccount(ACCOUNT_DATA *account) {
+  if(account->name)       free(account->name);
+  if(account->password)   free(account->password);
+  if(account->aux)        deleteAuxiliaryData(account->aux);
+  if(account->characters) deleteListWith(account->characters, free);
+  free(account);
+}
+
+ACCOUNT_DATA *accountRead(STORAGE_SET *set) {
+  ACCOUNT_DATA *account = calloc(1, sizeof(ACCOUNT_DATA));
+  accountSetName(account,            read_string(set, "name"));
+  accountSetPassword(account,    read_string(set, "password"));
+  account->aux = auxiliaryDataRead(read_set(set, "auxiliary"),
+				   AUXILIARY_TYPE_ACCOUNT);
+  account->characters = gen_read_list(read_list(set, "characters"), 
+				      accountReadChar);
+  listSortWith(account->characters, strcasecmp);
+  return account;
+}
+
+STORAGE_SET *accountStore(ACCOUNT_DATA *account) {
+  STORAGE_SET *set = new_storage_set();
+  store_string(set, "name",     account->name);
+  store_string(set, "password", account->password);
+  store_list  (set, "characters", gen_store_list(account->characters, 
+						 accountStoreChar));
+  store_set   (set, "auxiliary", auxiliaryDataStore(account->aux));
+  return set;
+}
+
+void accountCopyTo(ACCOUNT_DATA *from, ACCOUNT_DATA *to) {
+  if(to->characters) deleteListWith(to->characters, free);
+  auxiliaryDataCopyTo(from->aux, to->aux);
+  accountSetName(to, from->name);
+  accountSetPassword(to, from->password);
+  to->characters = listCopyWith(from->characters, strdup);
+}
+
+ACCOUNT_DATA *accountCopy(ACCOUNT_DATA *account) {
+  ACCOUNT_DATA *newacct = newAccount();
+  accountCopyTo(account, newacct);
+  return newacct;
+}
+
+void accountPutChar(ACCOUNT_DATA *account, const char *name) {
+  // make sure it's not already in
+  if(!listGetWith(account->characters, name, strcasecmp))
+    listPut(account->characters, strdup(name));
+}
+
+void accountRemoveChar(ACCOUNT_DATA *account, const char *name) {
+  char *elem = listRemoveWith(account->characters, name, strcasecmp);
+  if(elem) free(elem);
+}
+
+LIST *accountGetChars(ACCOUNT_DATA *account) {
+  return account->characters;
+}
+
+void *accountGetAuxiliaryData(ACCOUNT_DATA *account, const char *data) {
+  return hashGet(account->aux, data);
+}
+
+void accountSetPassword(ACCOUNT_DATA *account, const char *password) {
+  if(account->password) free(account->password);
+  account->password = strdup(password ? password : "");
+}
+
+const char *accountGetPassword(ACCOUNT_DATA *account) {
+  return account->password;
+}
+
+void accountSetName(ACCOUNT_DATA *account, const char *name) {
+  if(account->name) free(account->name);
+  account->name = strdup(name ? name : "");
+}
+
+const char *accountGetName(ACCOUNT_DATA *account) {
+  return account->name;
+}
diff -ruN ../nakedmudv2.1.1/src/account.d src/account.d
--- ../nakedmudv2.1.1/src/account.d	Wed Dec 31 17:00:00 1969
+++ src/account.d	Thu May 12 17:17:50 2005
@@ -0,0 +1,2 @@
+account.d account.o: account.c mud.h wrapsock.h property_table.h list.h map.h \
+  hashtable.h set.h buffer.h bitvector.h auxiliary.h storage.h account.h
diff -ruN ../nakedmudv2.1.1/src/account.h src/account.h
--- ../nakedmudv2.1.1/src/account.h	Wed Dec 31 17:00:00 1969
+++ src/account.h	Thu May 12 17:08:52 2005
@@ -0,0 +1,33 @@
+#ifndef ACCOUNT_H
+#define ACCOUNT_H
+//*****************************************************************************
+//
+// account.h
+//
+// Players first create an account, and then they can begin creating players.
+// The main purpose of an account is to hold all of the information relevant to
+// one player, which might extend all of that player's game characters. If you 
+// plan on adding any other information to accounts, it is strongly suggested 
+// you do so through auxiliary data (see auxiliary.h).
+//
+// For a recap, IF YOU PLAN ON ADDING ANY OTHER INFORMATION TO ACCOUNTS, IT
+// IS STRONGLY SUGGESTED YOU DO SO THROUGH AUXILIARY DATA (see auxiliary.h).
+//
+//*****************************************************************************
+
+ACCOUNT_DATA       *newAccount(void);
+void             deleteAccount(ACCOUNT_DATA *account);
+ACCOUNT_DATA      *accountRead(STORAGE_SET *set);
+STORAGE_SET      *accountStore(ACCOUNT_DATA *account);
+void             accountCopyTo(ACCOUNT_DATA *from, ACCOUNT_DATA *to);
+ACCOUNT_DATA      *accountCopy(ACCOUNT_DATA *account);
+void            accountPutChar(ACCOUNT_DATA *account, const char *name);
+void         accountRemoveChar(ACCOUNT_DATA *account, const char *name);
+LIST          *accountGetChars(ACCOUNT_DATA *account);
+void  *accountGetAuxiliaryData(ACCOUNT_DATA *account, const char *data);
+void        accountSetPassword(ACCOUNT_DATA *account, const char *password);
+const char *accountGetPassword(ACCOUNT_DATA *account);
+void            accountSetName(ACCOUNT_DATA *account, const char *name);
+const char     *accountGetName(ACCOUNT_DATA *account);
+
+#endif // ACCOUNT_H
diff -ruN ../nakedmudv2.1.1/src/account_handler.c src/account_handler.c
--- ../nakedmudv2.1.1/src/account_handler.c	Wed Dec 31 17:00:00 1969
+++ src/account_handler.c	Thu May 12 17:22:38 2005
@@ -0,0 +1,354 @@
+//*****************************************************************************
+//
+// account_handler.c
+//
+// The login and creation of accounts, and handles all of the account procedures
+// load loading and deleting characters. If you are looking to change the char
+// creation menu, you will want char_gen.c, not account_handler.c
+//
+//*****************************************************************************
+
+#include "mud.h"
+#include "utils.h"
+#include "socket.h"
+#include "account.h"
+#include "character.h"
+#include "inform.h"
+#include "save.h"
+#include "char_gen.h"
+
+
+
+//*****************************************************************************
+// mandatory modules
+//*****************************************************************************
+#include "scripts/script.h"
+
+// mccp support
+const unsigned char do_echo   [] = { IAC, WONT, TELOPT_ECHO,      '\0' };
+const unsigned char dont_echo [] = { IAC, WILL, TELOPT_ECHO,      '\0' };
+
+// account input handlers
+void account_ask_name       (SOCKET_DATA *sock, char *arg);
+void account_ask_password   (SOCKET_DATA *sock, char *arg);
+void account_new_password   (SOCKET_DATA *sock, char *arg);
+void account_verify_password(SOCKET_DATA *sock, char *arg);
+void account_handle_menu    (SOCKET_DATA *sock, char *arg);
+void account_new_char       (SOCKET_DATA *sock, char *arg);
+void account_change_password(SOCKET_DATA *sock, char *arg);
+
+// and prompts
+void account_menu           (SOCKET_DATA *sock);
+
+
+//
+// the head honcho. This is the first handler that a socket enters once it has
+// connected to the game. You should use this function to get your login 
+// procedure rolling.
+void handle_new_connections(SOCKET_DATA *sock, char *arg) {
+  account_ask_name(sock, arg);
+}
+
+
+
+//*****************************************************************************
+// implementation of account input handlers
+//*****************************************************************************
+
+//
+// returns TRUE if the account has a valid name, and FALSE if it does not.
+// alphanumeric characters and digits are allows. Min length 4, max length 12.
+// first character must be a letter
+bool check_account_name(const char *name) {
+  int i, len = strlen(name);
+  if(len < 3 || len > 12)
+    return FALSE;
+  if(!isalpha(*name))
+    return FALSE;
+  for(i = 1; name[i] != '\0'; i++)
+    if(!isdigit(name[i]) && !isalpha(name[i]))
+      return FALSE;
+  return TRUE;
+}
+
+
+//
+// Asks for an account name. If this is a new account, then proceed to ask and
+// verify the password. Otherwise, ask for an account password and make sure it
+// matches the actual password.
+void account_ask_name(SOCKET_DATA *sock, char *arg) {
+  // make sure we're not still resolving the DNS
+  if (socketGetDNSLookupStatus(sock) != TSTATE_DONE) {
+    text_to_buffer(sock, 
+		   "Making a dns lookup, please have patience.\n\r"
+		   "What is your account name? ");
+    return;
+  }
+
+  // check for a legal account name
+  if (!check_account_name(arg)) {
+    text_to_buffer(sock, 
+		   "Sorry, that's not a legal account name. Your account name must only consist of\r\n"
+		   "characters and numbers, and it must be between 4 and 12 characters long. The\r\n"
+		   "first character MUST be a letter. Please pick another.\r\n"
+		   "What is your name? ");
+    return;
+  }
+
+  // all is good. See if the account exists already
+  else {
+    ACCOUNT_DATA *acct = NULL;
+    log_string("Account '%s' is trying to connect.", arg);
+
+    // check for new account
+    if ( (acct = load_account(arg)) == NULL) {
+      // check for lockdown
+      if(mudsettingGetInt("lockdown") > 0) {
+	text_to_socket(sock, "Sorry, creating new accounts is not allowed at the moment.\r\n");
+	close_socket(sock, FALSE);
+	return;
+      }
+
+      // make a new account and give it a name
+      acct = newAccount();
+      accountSetName(acct, arg);
+
+      // prepare for next step 
+      text_to_buffer(sock, "Please enter a new password: ");
+      socketReplaceInputHandler(sock, account_new_password, NULL);
+    }
+
+    // old account
+    else {
+      // prepare for next step 
+      text_to_buffer(sock, "What is your password? ");
+      socketReplaceInputHandler(sock, account_ask_password, NULL);
+    }
+
+    // make sure the password entry is not displayed on screen
+    text_to_buffer(sock, (char *)dont_echo);
+
+    // attach the account to the socket
+    socketSetAccount(sock, acct);
+  }
+}
+
+
+//
+// Ask for a password, and make sure it matches the account's password. If it
+// does not, then dc the socket
+void account_ask_password   (SOCKET_DATA *sock, char *arg) {
+  // make sure we can start seeing what we type, again
+  text_to_buffer(sock, (char *) do_echo);
+
+  // Passwords match. Go to the account menu
+  if (compares(crypt(arg, accountGetName(socketGetAccount(sock))), 
+	       accountGetPassword(socketGetAccount(sock)))) {
+    socketReplaceInputHandler(sock, account_handle_menu, account_menu);
+  }
+  else {
+    text_to_socket(sock, "\007\007Bad password! Disconnecting.\r\n");
+    close_socket(sock, FALSE);
+  }
+}
+
+
+//
+// Ask and verify a new password during account creation
+void account_new_password   (SOCKET_DATA *sock, char *arg) {
+  // make sure the password is an acceptable length
+  if (strlen(arg) < 5 || strlen(arg) > 12) {
+    text_to_buffer(sock, 
+		   "\r\nBetween 5 and 12 chars please!\n\r"
+		   "Please enter a new password: ");
+    return;
+  }
+
+  // encrypt and set the password
+  accountSetPassword(socketGetAccount(sock), 
+		     crypt(arg, accountGetName(socketGetAccount(sock))));
+
+  // move onto the next step
+  text_to_buffer(sock, "\r\nPlease verify the password: ");
+  socketReplaceInputHandler(sock, account_verify_password, NULL);
+}
+
+
+//
+// Verify the password during account creation. If there is a password mismatch,
+// then restart the password process.
+void account_verify_password(SOCKET_DATA *sock, char *arg) {
+  if (compares(crypt(arg, accountGetName(socketGetAccount(sock))), 
+	       accountGetPassword(socketGetAccount(sock)))) {
+    text_to_buffer(sock, (char *)do_echo);
+
+    // account created. Save it, and plop it into the account menu
+    save_account(socketGetAccount(sock));
+    socketReplaceInputHandler(sock, account_handle_menu, account_menu);
+  }
+  else {
+    accountSetPassword(socketGetAccount(sock), NULL);
+    text_to_buffer(sock, 
+		   "\r\nPassword mismatch!\n\r"
+		   "Please enter a new password: ");
+    socketReplaceInputHandler(sock, account_new_password, NULL);
+  }
+}
+
+//
+// Load up an existing character attached to the account. Enter the game
+void account_load_char(SOCKET_DATA *sock, int ch_num) {
+  ACCOUNT_DATA *acct = socketGetAccount(sock);
+  char *ch_name      = NULL;
+  if((ch_name = listGet(accountGetChars(acct), ch_num)) == NULL)
+    text_to_buffer(sock, "Invalid choice!\r\n");
+  else {
+    CHAR_DATA *ch = check_reconnect(ch_name);
+    // this character is already in-game. Disconnect them
+    if(ch != NULL) { 
+      // attach the character
+      socketSetChar(sock, ch);
+      charSetSocket(ch, sock);
+
+      log_string("%s has reconnected.", charGetName(ch));
+
+      // and let him enter the game. Replace the load character input handler
+      // with the one for playing the game.
+      socketPushInputHandler(sock, handle_cmd_input, show_prompt);
+      text_to_buffer(sock, "You take over a body already in use.\n\r");
+    }
+
+    // hmmm... our pfile is missing!!
+    else if ((ch = load_player(ch_name)) == NULL)
+      text_to_socket(sock, "ERROR: Your pfile is missing!\n\r");
+
+    // everything is OK
+    else {
+      // attach the new player 
+      socketSetChar(sock, ch);
+      charSetSocket(ch, sock);
+
+      // make sure the mud isn't locked to this person
+      if(charGetLevel(ch) < mudsettingGetInt("lockdown")) {
+	text_to_socket(sock, "Sorry, the mud is currently locked down to anyone of your level and below.\r\n");
+	deleteChar(ch);
+	socketSetChar(sock, NULL);
+	return;
+      }
+
+      // try putting the character into the game. Pop the input handler
+      // if we cannot
+      if(try_enter_game(ch)) {
+	log_string("%s has entered the game.", charGetName(ch));
+	// we're no longer in the creation process... attach the game
+	// input handler
+	socketPushInputHandler(sock, handle_cmd_input, show_prompt);
+
+	text_to_buffer(sock, motd);
+	look_at_room(ch, charGetRoom(ch));
+
+	// check enterance scripts
+	try_enterance_script(ch, charGetRoom(ch), NULL);
+      }
+      else {
+	text_to_buffer(sock, "There was a problem entering the game. Try again later!\r\n");
+	// do not extract, just delete. We failed to enter
+	// the game, so there is no need to extract from the game.
+	deleteChar(socketGetChar(sock));
+	socketSetChar(sock, NULL);
+      }
+    }
+  }
+}
+
+
+//
+// Change the password on an already-existant account
+void account_change_password(SOCKET_DATA *sock, char *arg) {
+  if (compares(crypt(arg, accountGetName(socketGetAccount(sock))), 
+	       accountGetPassword(socketGetAccount(sock)))) {
+    text_to_buffer(sock, "\r\nPlease enter a new password: ");
+    socketReplaceInputHandler(sock, account_new_password, NULL);
+  }
+  else {
+    text_to_buffer(sock, "\r\nIncorrect password!\r\n");
+    socketReplaceInputHandler(sock, account_handle_menu, account_menu);
+  }
+}
+
+
+//
+// handle all of the options in the account main menu
+void account_handle_menu(SOCKET_DATA *sock, char *arg) {
+  // are we trying to load up a character?
+  if(isdigit(*arg))
+    account_load_char(sock, atoi(arg));
+
+  // we're doing a menu choice
+  else switch(toupper(*arg)) {
+  case 'Q':
+    // quit the menu
+    text_to_buffer(sock, "Come back soon!\r\n");
+    save_account(socketGetAccount(sock));
+    socketPopInputHandler(sock);
+    break;
+
+  case 'P':
+    // change password
+    text_to_buffer(sock, (char *)dont_echo);
+    text_to_buffer(sock, "Enter old password: ");
+    socketReplaceInputHandler(sock, account_change_password, NULL);
+    break;
+
+  case 'N':
+    // make a new character
+    if(mudsettingGetBool("lockdown") > 0) {
+      text_to_buffer(sock, "The MUD is currently locked to new players.\r\n");
+      return;
+    }
+    start_char_gen(sock);
+    break;
+
+  default:
+    text_to_buffer(sock, "Invalid choice!\r\n");
+    break;
+  }
+}
+
+
+//
+// Display a list of all the account's characters to the account.
+void display_account_chars(SOCKET_DATA *sock) {
+  static char fmt[100];
+  int print_room, num_cols = 3, i = 0;
+  char *str = NULL;
+  LIST_ITERATOR *ch_i =newListIterator(accountGetChars(socketGetAccount(sock)));
+
+  print_room = (80 - 10*num_cols)/num_cols;
+  sprintf(fmt, "  {c%%2d{g) %%-%ds%%s", print_room);
+
+  text_to_buffer(sock, "\r\n{wPlay a Character:\r\n");
+  ITERATE_LIST(str, ch_i) {
+    send_to_socket(sock, fmt, i, str, (i % num_cols == (num_cols - 1) ? 
+				       "\r\n" : "   "));
+    i++;
+  } deleteListIterator(ch_i);
+
+  if(i % num_cols != 0)
+    send_to_socket(sock, "\r\n");
+}
+
+
+void account_menu(SOCKET_DATA *sock) {
+  // if we have some characters created, display them
+  if(listSize(accountGetChars(socketGetAccount(sock))) > 0)
+    display_account_chars(sock);
+
+  // additional options? delete? who's online?
+  text_to_buffer(sock,
+		 "\r\n{wAdditional Options:\r\n"
+		 "  {g[{cP{g]assword change\r\n"
+		 "  {g[{cN{g]ew character\r\n"
+		 "\r\n"
+		 "Enter choice, or Q to quit:{n ");
+}
diff -ruN ../nakedmudv2.1.1/src/account_handler.d src/account_handler.d
--- ../nakedmudv2.1.1/src/account_handler.d	Wed Dec 31 17:00:00 1969
+++ src/account_handler.d	Thu May 12 17:31:45 2005
@@ -0,0 +1,3 @@
+account_handler.d account_handler.o: account_handler.c mud.h wrapsock.h property_table.h \
+  list.h map.h hashtable.h set.h buffer.h bitvector.h utils.h socket.h \
+  account.h character.h inform.h save.h char_gen.h scripts/script.h
diff -ruN ../nakedmudv2.1.1/src/action.c src/action.c
--- ../nakedmudv2.1.1/src/action.c	Sun May  8 15:04:45 2005
+++ src/action.c	Thu May 12 17:08:52 2005
@@ -119,7 +119,7 @@
 //*****************************************************************************
 void init_actions() {
   // use the standard pointer hasher and comparator
-  actors = newMap(NULL, NULL, 50);
+  actors = newMap(NULL, NULL);
 
   // add in our example delayed action
   add_cmd("dsay", NULL, cmd_dsay, 0, POS_SITTING, POS_FLYING, 
@@ -205,17 +205,22 @@
 
 void pulse_actions(int time) {
   MAP_ITERATOR   *ch_i = newMapIterator(actors);
-  void          *actor = NULL;
-  ACTION_DATA  *action = NULL;
-  LIST_ITERATOR *act_i = NULL;
-  LIST        *actions = NULL;
+  ACTION_DATA   *action = NULL;
+  LIST_ITERATOR  *act_i = NULL;
+  LIST         *actions = NULL;
+  const CHAR_DATA *map_actor = NULL;
+  CHAR_DATA         *ch = NULL;
 
-  while( (actor = mapIteratorCurrentKey(ch_i)) != NULL) {
+  ITERATE_MAP(map_actor, actions, ch_i) {
     actions = mapIteratorCurrentVal(ch_i);
-    mapIteratorNext(ch_i);
 
     // if we have actions, then go through 'em all
     if(listSize(actions) > 0) {
+      // eek... small problem. The key for maps is constant, but we need
+      // a non-constant character to send to run_action. Let's get the char's
+      // UID, and re-look him up in the player table
+      ch = propertyTableGet(mob_table, charGetUID(map_actor));
+
       act_i = newListIterator(actions);
 
       ITERATE_LIST(action, act_i) {
@@ -224,12 +229,10 @@
 	// pop the action from the list, and run it
 	if(action->delay <= 0) {
 	  listRemove(actions, action);
-	  run_action(actor, action);
+	  run_action(ch, action);
 	  deleteAction(action);
 	}
-      }
-      deleteListIterator(act_i);
+      } deleteListIterator(act_i);
     }
-  }
-  deleteMapIterator(ch_i);
+  } deleteMapIterator(ch_i);
 }
diff -ruN ../nakedmudv2.1.1/src/autorun.py src/autorun.py
--- ../nakedmudv2.1.1/src/autorun.py	Sun May  8 15:04:45 2005
+++ src/autorun.py	Thu May 12 17:08:52 2005
@@ -1,3 +1,4 @@
+#!/usr/bin/python
 ################################################################################
 #
 # autorun.py
diff -ruN ../nakedmudv2.1.1/src/auxiliary.c src/auxiliary.c
--- ../nakedmudv2.1.1/src/auxiliary.c	Sun May  8 15:04:45 2005
+++ src/auxiliary.c	Thu May 12 17:08:52 2005
@@ -27,7 +27,6 @@
 //
 // the function sets used for loading and saving 
 // auxiliary functions on our datatypes
-//
 HASHTABLE *auxiliary_manip_funcs = NULL;
 
 
@@ -90,10 +89,10 @@
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
 
-  ITERATE_HASH(name, funcs, hash_i)
+  ITERATE_HASH(name, funcs, hash_i) {
     if(IS_SET(funcs->aux_type, aux_type))
       hashPut(data, name, funcs->new());
-  deleteHashIterator(hash_i);
+  } deleteHashIterator(hash_i);
   return data;
 }
 
@@ -104,10 +103,10 @@
   AUXILIARY_FUNCS *funcs = NULL;
   const char       *name = NULL;
 
-  ITERATE_HASH(name, funcs, hash_i) 
+  ITERATE_HASH(name, funcs, hash_i) {
     if(IS_SET(funcs->aux_type, aux_type) && !hashGet(data, name))
       hashPut(data, name, funcs->new());
-  deleteHashIterator(hash_i);
+  } deleteHashIterator(hash_i);
 }
 
 
@@ -122,8 +121,7 @@
   ITERATE_HASH(name, entry, hash_i) {
     funcs = auxiliariesGetFuncs(name);
     funcs->delete(entry);
-  }
-  deleteHashIterator(hash_i);
+  } deleteHashIterator(hash_i);
   deleteHashtable(data);
 }
 
@@ -138,9 +136,9 @@
 
   ITERATE_HASH(name, entry, hash_i) {
     funcs = auxiliariesGetFuncs(name);
-    store_set(set, name, funcs->store(entry));
-  }
-  deleteHashIterator(hash_i);
+    if(funcs->store) 
+      store_set(set, name, funcs->store(entry));
+  } deleteHashIterator(hash_i);
   return set;
 }
 
@@ -155,9 +153,11 @@
   ITERATE_HASH(name, funcs, hash_i) {
     if(!IS_SET(funcs->aux_type, aux_type))
       continue;
-    hashPut(data, name, funcs->read(read_set(set, name)));
-  }
-  deleteHashIterator(hash_i);
+    if(funcs->read)
+      hashPut(data, name, funcs->read(read_set(set, name)));
+    else
+      hashPut(data, name, funcs->new());
+  } deleteHashIterator(hash_i);
   return data;
 }
 
@@ -175,8 +175,7 @@
     ITERATE_HASH(name, entry, hash_i) {
       funcs = auxiliariesGetFuncs(name);
       funcs->delete(entry);
-    }
-    deleteHashIterator(hash_i);
+    } deleteHashIterator(hash_i);
   }
 
   // now, copy in all of the new data
@@ -185,8 +184,7 @@
     ITERATE_HASH(name, entry, hash_i) {
       funcs = auxiliariesGetFuncs(name);
       hashPut(to, name, funcs->copy(entry));
-    }
-    deleteHashIterator(hash_i);
+    } deleteHashIterator(hash_i);
   }
 }
 
diff -ruN ../nakedmudv2.1.1/src/auxiliary.h src/auxiliary.h
--- ../nakedmudv2.1.1/src/auxiliary.h	Sun May  8 15:04:45 2005
+++ src/auxiliary.h	Thu May 12 17:08:51 2005
@@ -19,6 +19,8 @@
 #define AUXILIARY_TYPE_OBJ       (1 << 2)
 #define AUXILIARY_TYPE_ZONE      (1 << 3)
 #define AUXILIARY_TYPE_SOCKET    (1 << 4)
+#define AUXILIARY_TYPE_ACCOUNT   (1 << 5)
+
 
 
 //
diff -ruN ../nakedmudv2.1.1/src/bitvector.c src/bitvector.c
--- ../nakedmudv2.1.1/src/bitvector.c	Sun May  8 15:04:45 2005
+++ src/bitvector.c	Thu May 12 17:08:51 2005
@@ -99,8 +99,7 @@
 }
 
 BITVECTOR *newBitvector() {
-  BITVECTOR *v = malloc(sizeof(BITVECTOR));
-  bzero(v, sizeof(BITVECTOR));
+  BITVECTOR *v = calloc(1, sizeof(BITVECTOR));
   return v;
 }
 
@@ -111,8 +110,7 @@
     int vector_len = hashSize(data->bitmap)/8 + 1;
     vector = newBitvector();
     vector->data = data;
-    vector->bits = malloc(sizeof(char) * vector_len);
-    bzero(vector->bits, vector_len);
+    vector->bits = calloc(vector_len, sizeof(char));
   }
   return vector;
 }
